//---------------------------------------------------------------------------

#include <vcl.h>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


//       ,
//    
template <class T>
class AddValue {
  private:
    T theValue;    // 
  public:
    //   
    AddValue (const T& v) : theValue(v) {
    }

    //   " "  
    void operator() (T& elem) const {
        elem += theValue;
    }
};

int main()
{
  vector<int> coll;

  INSERT_ELEMENTS(coll,1,9);

  //   ;
  PRINT_ELEMENTS(coll," :\n");

  //     10
  for_each (coll.begin(), coll.end(),       // 
            AddValue<int>(10));             // 
  PRINT_ELEMENTS(coll,"    10:\n");

  //       
  for_each (coll.begin(), coll.end(),       // 
            AddValue<int>(*coll.begin()));  // 
  PRINT_ELEMENTS(coll,"     1- :\n");

  getch();
  return 0;
}

//---------------------------------------------------------------------------